]> git.phdru.name Git - dotfiles.git/blob - .shellrc
Feat(recode-filenames-recursive): Allow to omit parameters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    if [ -d "$HOME"/.bash_completion.d ]; then
102       for _compf in "$HOME"/.bash_completion.d/*; do
103          . $_compf
104       done
105    fi
106
107    for cmd in builtin cgmem_nice command dbus-launch exec \
108       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
109       time whence whereis which xargs; do
110          ! has_completion $cmd && complete -o default -A command $cmd
111    done
112
113    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
114       telnet t tt \
115       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
116       whois wget wget-m wget-wrapper ww; do
117          ! has_completion $cmd && complete -A hostname $cmd
118    done
119
120    for cmd in distribute ftp lftp r rsync \
121       s scp ssh smbclient tcpdump tshark wireshark; do
122          ! has_completion $cmd && complete -o default -A hostname $cmd;
123    done
124
125    delegate_completion() {
126       local prog programs
127       prog=$1
128       if has_completion $prog; then
129          shift
130          programs="$@"
131          eval "_${prog}_completion_loader() {
132             _completion_loader $prog
133             complete -F _$prog $programs
134             unset _${prog}_completion_loader
135             return 124
136          }"
137          complete -F _${prog}_completion_loader $programs
138       fi
139    }
140
141    delegate_completion make m
142    delegate_completion ping p
143    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
144    delegate_completion ssh s
145    delegate_completion wget wget-m wget-wrapper ww
146
147    unset has_completion delegate_completion
148
149    complete -A job bg fg j jobs wait
150    complete -A variable -A function unset
151
152    if [ -d "$HOME/lib/config" ]; then
153       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
154    fi
155    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
156
157    #if type -p pip >/dev/null 2>&1; then
158    #   eval "`pip completion --bash`"
159    #   rm -rf /tmp/pip_build_"$USER"
160    #fi
161
162    #if which pyenv >/dev/null 2>&1; then
163    #   eval "`pyenv init -`"
164    #   eval "`pyenv virtualenv-init -`"
165    #fi
166
167    source virtualenvwrapper_lazy.sh 2>/dev/null
168
169    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
170       . "$VIRTUAL_ENV/bin/activate"
171    fi
172
173    # Clean up python virtual environment on exit
174    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
175
176    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
177
178 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
179    back() { cd - "$@"; }
180    j() { jobs; }
181 fi
182
183
184 # clear screen and history, logout
185 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
186
187
188 if test -x /usr/bin/git >/dev/null 2>&1; then
189    # chdir to a directory
190    cdgitpath() {
191       if [ $# -ne 1 ]; then
192          echo "Usage: cdgitpath path_key" >&2
193          return 1
194       fi
195
196       path_key="$1"
197       if [ -z "$path_key" ]; then
198          echo "Usage: cdgitpath path_key" >&2
199          return 1
200       fi
201
202       path_url="`git config --get --path $path_key`"
203       if echo "$path_url" | grep -q '^file:/'; then
204          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
205       fi
206       cd "$path_url"
207    }
208
209    # chdir to a remote's directory (if the remote is on the local FS)
210    cdremote() {
211       if [ $# -gt 1 ]; then
212          echo "Usage: cdremote [remote_name]" >&2
213          return 1
214       fi
215
216       if [ -z "$1" ]; then
217          branch="`git rev-parse --abbrev-ref HEAD`"
218          remote="`git config --get branch.$branch.remote`"
219       else
220          remote="$1"
221       fi
222
223       if [ -n "$remote" ] && git config --get remote.$remote.url | grep -q '^\(file:/\|/\|\.\./\)'; then
224          cdgitpath remote.$remote.url
225       else
226
227          if [ -n "$1" ]; then
228             echo "Cannot find directory for remote $1" >&2
229             echo "Usage: cdremote [remote_name]" >&2
230             return 1
231          fi
232
233          _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
234          if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
235             remote=${GIT_REMOTES[0]}
236             unset GIT_REMOTES
237             cdgitpath remote.$remote.url
238          else
239             unset GIT_REMOTES
240             echo "Cannot find directory for any remote" >&2
241             echo "Usage: cdremote [remote_name]" >&2
242             return 1
243          fi
244       fi
245    }
246
247    if test -n "$BASH_VERSION"; then
248       # completion for aliases in global .gitconfig
249
250       # fixup rbi rbia rbiap rbip - do refs name completion
251       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
252       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
253       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
254       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
255       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
256       #
257       # push-to-all-remotes - do branch name completion
258       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
259
260       _cdgitpath_complete() {
261          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
262          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
263       }
264
265       _git_open() {
266          _cdgitpath_complete
267       }
268
269       complete -F _cdgitpath_complete cdgitpath git-open
270
271       # list remotes with URLs matching a regexp
272       _list_remotes() {
273          if [ $# -ne 1 ]; then
274             echo "Usage: _list_remotes remote_regexp" >&2
275             return 1
276          fi
277          declare -ag GIT_REMOTES=()
278          local remote
279          for remote in `git remote`; do
280             if git config --get remote.$remote.url | grep -q "$1"; then
281                GIT_REMOTES+=($remote)
282             fi
283          done
284       }
285
286       # completion for cdremote and git-open-remote - list remotes with a pattern
287       _list_remotes_completion() {
288          local cur="${COMP_WORDS[COMP_CWORD]}";
289          _list_remotes "$1"
290          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
291          unset GIT_REMOTES
292       }
293
294       # completion for cdremote - list remotes with directories as URLs
295       _cdremote_complete() {
296          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
297          if [ ${#COMPREPLY[*]} -eq 0 ]; then
298             _list_remotes_completion .
299          fi
300       }
301
302       complete -F _cdremote_complete cdremote
303
304       # completion for git-open-remote - list remotes with http(s) URLs
305       _git_open_remote() {
306          _list_remotes_completion '^http\(s\)\?://'
307          if [ ${#COMPREPLY[*]} -eq 0 ]; then
308             _list_remotes_completion .
309          fi
310       }
311
312       complete -F _git_open_remote git-open-remote
313    fi
314 fi
315
316
317 include() {
318    cfg="$1"
319    if [ -f "./$cfg" -a -r "./$cfg" ]; then
320       echo "Reading config file \`$cfg'" 1>&2
321       . "./$cfg"
322    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
323       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
324       . "$HOME/lib/config/$cfg"
325    else
326       echo "Cannot find config file \`$cfg'" 1>&2
327    fi
328 }
329
330
331 mc() {
332    if test -n "$BASH_VERSION"; then
333       MC_SAVE_OPS1="$OPS1"
334       OPS1="\u@\h "
335    fi
336
337    if [ -n "$SLOWTERM" ]; then
338       MC_SLOW="--slow"
339    fi
340
341    case "$TERM" in
342       screen*) # screen, screen.rxvt
343          MC_XTERM="-x"
344       ;;
345    esac
346
347    #TMPDIR="$HOME"/tmp
348    #export TMPDIR
349
350    MC_FOUND=NO
351
352    for wrapper in \
353          /usr/local/share/mc/bin/mc-wrapper.sh \
354          /usr/local/libexec/mc/mc-wrapper.sh \
355          /usr/share/mc/bin/mc-wrapper.sh; do
356       if [ -r $wrapper ]; then
357          . $wrapper $MC_SLOW $MC_XTERM "$@"
358          rc=$?
359          MC_FOUND=YES
360          break
361       fi
362    done
363
364    if [ $MC_FOUND = NO ]; then
365       for mc in /usr/local/bin/mc /usr/bin/mc; do
366          if [ -x $mc ]; then
367             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
368             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
369                MC_TMP_DIR="${TMPDIR-/tmp}"
370             fi
371             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
372             mc_type="`mc_type.py $mc`"
373             if [ "$mc_type" = old ]; then
374                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
375             elif [ "$mc_type" = new ]; then
376                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
377             else
378                continue
379             fi
380             rc=$?
381             MC_FOUND=YES
382             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
383             break
384          fi
385       done
386    fi
387
388    if [ $MC_FOUND = NO ]; then
389       echo "Cannot find mc-wrapper.sh or mc" >&2
390       rc=1
391    fi
392
393    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
394    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
395
396    return $rc
397 }
398
399
400 mkcd() {
401    if [ $# -ne 1 ]; then
402       echo "Usage: mkcd directory_name" >&2
403    elif [ -d "$1" ]; then
404       cd "$1"
405    elif [ -e "$1" ]; then
406       echo "Error: $1 is a file" >&2
407    else
408       mkdir -p "$1" && cd "$1"
409    fi
410 }
411
412
413 if which tmux >/dev/null 2>&1; then
414    tmux() {
415       case "$TERM" in
416          rxvt)
417             TERM=rxvt-unicode command tmux "$@"
418          ;;
419
420          *)
421             command tmux "$@"
422          ;;
423       esac
424    }
425 fi
426
427
428 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
429    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
430 fi
431
432 x() { exit; }